import swarm.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import java.util.*;
import java.util.function.*;

/*
    Bugclass
    ɒl邱ƂŎsɓIɃp^ύXł悤ɂ
    łɕނBugɑ΂ĂIɈ悤ɂȂ
*/
public class BugCreator extends SwarmImpl {
    // probeɂ̂邽߂publicɂ
    public int bugType;
    public int moveType;
    public double bugDensity;
    public int bugNum; // ő剽C܂œoł邩 -1ŖɂȂ
    public float defaultSpeed;
    public float minSpeed;
    public float maxSpeed;
    public float accel;
    public float gravityWeight;
    public float nearWeight;
    public float repulRadian;
    public float avoidRadian;
    public float orientRadian;
    public float searchRadian;
    public float searchAngle;
    public float stdRotate;
    public float maxRotate;
    public float maxRotateInAvoiding;
    public int trailingNum;

    public BugCreator(Zone aZone, int bugType, int moveType, double bugDensity, int bugNum, float defaultSpeed, float minSpeed, float maxSpeed, float accel, float gravityWeight, float nearWeight, float repulRadian, float avoidRadian, float orientRadian, float searchRadian, float searchAngle, float stdRotate, float maxRotate, float maxRotateInAvoiding, int trailingNum) {
        super(aZone);
        this.bugType = bugType;
        this.moveType = moveType;
        this.bugDensity = bugDensity;
        this.bugNum = bugNum;
        this.defaultSpeed = defaultSpeed;
        this.minSpeed = minSpeed;
        this.maxSpeed = maxSpeed;
        this.accel = accel;
        this.gravityWeight = gravityWeight;
        this.nearWeight = nearWeight;
        this.repulRadian = repulRadian;
        this.avoidRadian = avoidRadian;
        this.orientRadian = orientRadian;
        this.searchRadian = searchRadian;
        this.searchAngle = searchAngle;
        this.stdRotate = stdRotate;
        this.maxRotate = maxRotate;
        this.maxRotateInAvoiding = maxRotateInAvoiding;
        this.trailingNum = trailingNum ;
    }

    public Object setProbeDisplay(){
        Globals.env.createArchivedProbeDisplay(this, "bugCreator");
        return this;
    }

    public Optional<Bug> create(Zone aZone) {
        Optional<Bug> ret = Optional.empty();
        if (Globals
        .env
        .uniformDblRand
        .getDoubleWithMin$withMax(0.0, 1.0)
        < bugDensity && bugNum != 0) {
            Bug aBug = new Bug(aZone, maxSpeed, minSpeed, accel, repulRadian, avoidRadian, orientRadian, searchRadian, searchAngle, gravityWeight, nearWeight, stdRotate, maxRotate, maxRotateInAvoiding, trailingNum, bugType, moveType);
            aBug.setVelocity(defaultSpeed,
                (float)Globals
                    .env
                    .uniformDblRand
                    .getDoubleWithMin$withMax(0.0, 360.0));
            if (bugNum > 0) {
                bugNum -= 1;
                // bugNum0ɂȂ܂bug̐
            }
            ret = Optional.of(aBug);
        }

        return ret;
    }
}
